 /**
 * The ADT specification for a Board Game (simiar to Naval Battle)
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 * 
 * @author Antonia Lopes
 * @version 1.0 - 21/Jan/2013
 **/
 
 specification Board
 
	sorts
		Board
		
	constructors
    	empty: int -->? Board;
    	take: Board int int -->? Board;
    	reveal: Board int int -->? Board;
    	
	observers
   	 	dim: Board --> int;
   	 	taken: Board int int;
		revealed: Board int int;
		
	others
   	 	free: Board int int;

  	domains
  	  	T: Board; 
  	  	i,j,n: int;
  	  	empty(n) if n>=1;
    	take(T,i,j) if i>=1 and i<=dim(T) and j>=1 and j<=dim(T);
    	reveal(T,i,j) if i>= 1 and i<=dim(T) and j>=1 and j<=dim(T);
    	
  	axioms
  	  	T: Board; n,i,j,k,l: int;
  	  	
		dim(empty(n)) = n;
		dim(take(T,i,j)) = dim(T);
		dim(reveal(T,i,j)) = dim(T);
				
		not taken(empty(n),k,l) if n>=1 and k>=1 and k<=n and l>=1 and l<=n;		
		taken(take(T,i,j),k,l) iff i>=1 and i<=dim(T) and j>=1 and j<=dim(T) 
								  and k>=1 and k<=dim(T) and l>=1 and l<=dim(T) 
								  and ((i=k and j=l) or taken(T,k,l));
		taken(reveal(T,i,j),k,l) iff i>=1 and i<=dim(T) and j>=1 and j<=dim(T) 
								   and k>=1 and k<=dim(T) and l>=1 
								   and l<=dim(T) and taken(T,k,l);
		
		not revealed(empty(n),k,l) if n>=1 and k>=1 and  k<=n and l>=1 and l<=n;
		revealed(reveal(T,i,j),k,l) iff i>=1 and i<=dim(T) and j>=1 and j<=dim(T) 
									and k>=1 and k<=dim(T) and l>=1 and l<=dim(T) 
									and ((i=k and j=l) or revealed(T,k,l));
		revealed(take(T,i,j),k,l) iff i>=1 and i<=dim(T) and j>=1 and j<=dim(T) 
								   and k>=1 and k<=dim(T) and l>=1 and l<=dim(T) 
								   and not(i=k and j=l) and revealed(T,k,l);
		
		free(T,i,j) iff i>=1 and i<=dim(T) and j>=1 and j<=dim(T) and 
						 (not taken(T,i,j)) and (i=1 or not taken(T,i-1,j)) and
						 (i=dim(T) or not taken(T,i+1,j)) and
						 (j=1 or not taken(T,i,j-1)) and
						 (j=dim(T) or not taken(T,i,j+1)) and
						 ((i=1 and j=1) or not taken(T,i-1,j-1)) and
						 (i=dim(T) or j=dim(T) or not taken(T,i+1,j+1)) and
						 (i=1 or j=dim(T) or not taken(T,i-1,j+1)) and
						 (i=dim(T) or j=1 or not taken(T,i+1,j-1)); 
	
		
end specification
