import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Scanner;

/**
 * A classe de teste de uma versao interativa do jogo Ipex
 * 
 * @author Antonia Lopes, Ana Santos
 * @version 1.1 - 21/Jan/2013 
 */
public class TabuleiroIOTest {

	/**
	 * O jogo Ipex que vai ser executado
	 */
	private Ipex jogo;
	
	/**
	 * Nome do ficheiro onde eh guardado resultado da partida
	 */
	private static String RESULTADOS = "resultados.txt";
	
	/**
	 * Construtor
	 * @param jogo - o jogo ipex a executar
	 */
	public TabuleiroIOTest(Ipex jogo) {
		this.jogo = jogo;
	}
	
	/**
	 * Efectua um jogo Ipex
	 */
	public void run(){
		
		Scanner sc = new Scanner(System.in);
		FileWriter fstream = null;
		BufferedWriter out = null;

		try {	
			fstream = new FileWriter(RESULTADOS,true);
			out = new BufferedWriter(fstream);
			out.write("----NOVA PARTIDA----\n");
		} catch (Exception e) { //Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}

		while(!jogo.terminado()) {  	
			boolean jvalida = false;
			int linha = 0;
			int coluna = 0;

			while(!jvalida) {  	
				System.out.println("Joga " + jogo.jogador() + ":");
				System.out.print("Linha: ");
				linha = sc.nextInt(); 
				System.out.print("Coluna: ");
				coluna = sc.nextInt();

				if(jogo.jogadaValida(linha,coluna))  
					jvalida = true;
				else
					System.out.println("Jogada Invalida");
			}

			try {
				out.write("Jogador = " + jogo.jogador() +
							" - Jogada = " + linha + ", " + coluna + "\n");
			} catch (Exception e){ //Catch exception if any
				System.err.println("Error: " + e.getMessage());
			}
			jogo.efectuaJogada(linha, coluna);
			System.out.print(jogo);
		}

		System.out.println("Vencedor = " +  jogo.vencedor() + ":");
		
		try {
			out.write("Vencedor = " + jogo.vencedor() + "\n");
			out.close();
			fstream.close();
		} catch (Exception e){ //Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		sc.close();	
	}
}