import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Random;

/**
 * A classe Main
 * 
 * @author Antonia Lopes, Ana Santos
 * @version 1.1 - 16/Jul/2013 
 */
public class TabuleiroRandomTest {

	/**
	 * Quantos jogos realizar	 
	 **/
	private int numeroDeJogos;

	/**
	 * Objeto random para gerar numeros aleatorios
	 **/
	private Random rand;

	/**
	 * Nome do ficheiro onde eh guardado resultado da partida
	 */
	private static String RESULTADOS = "resultados.txt";

	/**
	 * Efetua automaticamente um jogo Ipex e guarda os resultados
	 * num ficheiro
	 * @param numeroDeJogos - numero de jogos a executar
	 */
	public TabuleiroRandomTest(int numeroDeJogos) {		
		this.rand = new Random();
		this.numeroDeJogos = numeroDeJogos;
	}

	/**
	 * Executa o teste
	 */
	public void run() {

		for (int i = 0; i < numeroDeJogos; i++) {
			Ipex jogo = new Ipex();
			FileWriter fstream = null;
			BufferedWriter out = null;

			try {	
				fstream = new FileWriter((i+1) + "_" + RESULTADOS, true);
				out = new BufferedWriter(fstream);
				out.write("----NOVA PARTIDA----\n");
			} catch (Exception e) { //Catch exception if any
				System.err.println("Error: " + e.getMessage());
			}

			while(!jogo.terminado()){  	

				boolean jvalida = false;
				int linha = 1;
				int coluna = 1;

				while(!jvalida){  	
					System.out.println("Joga " + jogo.jogador() + ":");
					System.out.print("Linha: ");
					linha = gerarNumero(jogo.dimensao()); 
					System.out.println(linha);

					System.out.print("Coluna: ");
					coluna = gerarNumero(jogo.dimensao());
					System.out.println(coluna);

					if(jogo.jogadaValida(linha,coluna))  
						jvalida = true;
					else
						System.out.println("Jogada Invalida");
				}

				try {
					out.write("Jogador = " + jogo.jogador() +
							" - Jogada = " + linha + ", " + coluna + "\n");
				} catch (Exception e){ //Catch exception if any
					System.err.println("Error: " + e.getMessage());
				}
				jogo.efectuaJogada(linha, coluna);
				System.out.print(jogo);
			}

			try {
				out.write("Vencedor = " + jogo.vencedor() + "\n");
				out.close();
				fstream.close();
			} catch (Exception e){ //Catch exception if any
				System.err.println("Error: " + e.getMessage());
			}
		}
	}

	/**
	 * Metodo auxiliar que gera um numero aleatorio
	 * 
	 * @param n - numero maximo a gerar
	 * @return - numero aleatorio + 1
	 */
	private int gerarNumero(int n) {
		return rand.nextInt(n)+1;
	}
}